/* --------------------------------------------------------------------------
 * BreakOut
 * --------------------------------------------------------------------------
 * prog:  Nora Gailer
 * date:  04/10/2013 (m/d/y)
 * ----------------------------------------------------------------------------
 */
import ddf.minim.*;

Minim minim;
AudioSample ballHitSnd;
AudioSample ballHitSchlaegerSnd;

float _playfield;
float _kwinkel;
float _rotR= 0;
float _kreisR;
float  farbVariable;

int gameMode = GAME_MODE_MENU;
final static int GAME_MODE_MENU      = 0;
final static int GAME_MODE_PLAY      = 1;
final static int GAME_MODE_GAMEOVER  = 2;


ArrayList<Ball> balls;
ArrayList<HitBall> hitBalls;
ArrayList<Ball> playBall;
//int numBalls = 4;

void setup() {
  size(800, 800);
  translate(width/2, height/2);
  fill(0);
  textSize(17);
  _kwinkel = (360/18);
  _kreisR = 370;

  balls = new ArrayList<Ball>();
  hitBalls = new ArrayList<HitBall>();
  
   // sound init
  minim = new Minim(this);
  ballHitSnd = minim.loadSample("hit.mp3");
  ballHitSchlaegerSnd = minim.loadSample("hitSchlaeger.mp3");
  
  
  /*for (int i = 0; i < numBalls; i++) {
    //balls[i] = new Ball(400+cos(radians(_kwinkel *i)) * _kreisR, 400+sin(radians(_kwinkel*i)) * _kreisR, 20, i, balls);

    balls.add(new Ball(400+cos(radians(_kwinkel *i)) * _kreisR, 400+sin(radians(_kwinkel*i)) * _kreisR, 20, i, i));
  }*/
  

   //Ballkreis 
  for (int i=1;i<20;i++)
  {
    pushMatrix();
    balls.add(new Ball(400+cos(radians(_kwinkel *i)) * _kreisR, 400+sin(radians(_kwinkel*i)) * _kreisR, 25));
    //ellipse(cos(radians(_kwinkel *i)) * _kreisR, sin(radians(_kwinkel*i)) * _kreisR, _size, _size);
    popMatrix();
  }
  
  // Bälle in der Mitte zum Abschiessen
  for (int i=0;i<30;i++)
  {
    pushMatrix();
    //hitBalls.add(new HitBall(400+cos(radians(_kwinkel *i)) * 120, 400+sin(radians(_kwinkel*i)) * 120, 20));
    //ellipse(cos(radians(_kwinkel *i)) * _kreisR, sin(radians(_kwinkel*i)) * _kreisR, _size, _size);
    hitBalls.add(new HitBall(260 + (i % 5) * 70, 270+((int)(i/5)) * 55, 20));
    popMatrix();
  }
 /* pushMatrix();
  playBall.add(new Ball(width/2+200, height/2, 20));
  popMatrix();*/
}

void draw () {
  background(255);
  pushStyle();
  fill(255);
  stroke(0);
  strokeWeight(5);
  ellipse(width/2,height/2, _kreisR*2, _kreisR*2);
  popStyle();
  
  drawScene();
   
  for (Ball b : balls) {
    fill(0);
    b.update();
    b.display();
    b.checkBoundaryCollision();
  }
  _rotR = atan2(mouseY-height/2, mouseX-width/2);
  for (int i = 1; i < balls.size(); i++) {
    balls.get(i)._position.x = 400+cos(radians(_kwinkel *(i+_rotR))) * _kreisR;
    balls.get(i)._position.y = 400+sin(radians(_kwinkel*(i+_rotR))) * _kreisR;
    balls.get(0).checkBallCollision(balls.get(i));
  }

}

void drawScene()//modulierung von Spielablauf
{
  switch(gameMode)
  {
  case GAME_MODE_MENU:
    drawMenu();
    break;
  case GAME_MODE_PLAY:
    drawGame();
    break;  
  case GAME_MODE_GAMEOVER:
    drawGameOver();
    break;
  }
}

void drawMenu()
{
  pushStyle();
  fill(0);
  text("BreakOut", 330, 350);  

  text("\'SPACE\' : start game", 330, 380);  
  text("Z : stop game", 330, 410);   
  popStyle();
}
void drawGameOver()
{
  pushStyle();
  fill(0);
  text("Game Over", 330, 200);  
  popStyle();
}


void keyPressed()
{
  switch(key)
  {
  case ' ':
    // start game
    gameMode = GAME_MODE_PLAY;
    //initGameScene();
    break;
  case 'z':
    // end
    gameMode = GAME_MODE_MENU;
    break;
  }
}

void drawGame()
{
  // update die daten, berechne kollisionen
  //updaupdateScene();
 for (int i = hitBalls.size() - 1; 0 <= i; i--) {
   // hitBalls.get(i).display();
    
    if (hitBalls.get(i).isCollidingWithBall(balls.get(0))){
      //add points?
      hitBalls.remove(i);
      ballHitSnd.trigger();
    }
  }
  for (HitBall b : hitBalls) {
    pushStyle();
    stroke(44,255,200);
    strokeWeight(7);
    fill(0);
    b.display();
    popStyle();
    b.update();
     
    
    //b.checkBoundaryCollision();
  }
}


